(in-package "USER")

(defvar *goal* '(1 2 3 4 5 6 7 8 0))
(defvar *visited* nil)

(defun depth (start)
    (let ((path nil) x y result)
	(setf x (get-internal-run-time))
	(setf path (list start))
	(setf *visited* nil)
	(if (equal (first path) *goal*)
	    path
	    (setf result (depth-aux path nil))
	)
        (setf y (get-internal-run-time))
	(print result)
	(format t "Running time: ~S sec.~%"
		  (float (/ (- y x) internal-time-units-per-second))
        )
	(format t "Length: ~D~%" (length result))
	(format t "Removed duplicates length: ~D~%"
		  (length (remove-duplicates result))
	)
    )
)

(defun depth-aux(path lst)
    (let* ((current (first path))
	   (zloc (location 0 current))
	   (select nil)
	   (changed nil)
	   (child nil)
	  )
;	(if (null path) (print "path is NIL!!")
;			  (format t "Path:~S~%" path))
        (if lst
	    (setf select lst)
	    (setf select (rest (assoc zloc *next*)))
        )
;	(format t "Current: ~S~%" current)
;	(format t "zloc: ~D~%" zloc)
;	(format t "select: ~D~%" select)
	(setf changed (exchange zloc (first select) current))
	(progn
;	    (format t "Changed: ~D~%" changed)
	    (if (equal changed *goal*)
		(progn
		    (push changed path)
		    (reverse path)
		)
		(progn ;(push changed path)
;		       (format t "*visited*:~S~%" *visited*)
		(cond
		    ((member changed *visited* :test #'equal)
		    ; (print "*1*")
		     nil
		    )
		    ((member changed path :test #'equal)
		    ; (print "*2*")
		     (if (setf select (rest select))
			 (if (setf child (depth-aux path select))
			     child
		             nil
			 )
			 nil
		     )
		    )
		    (t
			(progn
			    (push changed path)
			    (setf child (depth-aux path nil))
;			    (format t "child: ~S~%" child)
			    (if child child
				(progn
			            (push changed *visited*)
;			            (format t "*visited*~S~%" *visited*)
				    (pop path)
				    (setf select (rest select))
				    (if select
					(progn ;(push changed path)
					;(print "*Second case*")
				        (depth-aux path select))
					nil
				    )
				)
			    )
			)
		    )
		))
	    )
	)
    )
)
