(in-package "USER")

(defun heuristic (lst)
    (similar lst *goal*)
)

(defun similar (lst1 lst2)
    (cond
	((null lst1) 0)
	((null lst2) 0)
	((equal (first lst1) (first lst2))
	    (+ 2 (similar (rest lst1) (rest lst2)))
        )
	((member (first lst1) (nth (first lst2) *next*))
	    (1+ (similar (rest lst1) (rest lst2)))
	)
	(t (similar (rest lst1) (rest lst2)))
    )
)
