(defun match4 (p s)
  (cond
    ((and (null p) (null s))		;null clause
     '((:yes . :yes)) )
    ((or (atom p)(atom s)) nil)		;atom clause
    ((equalp (first p) (first s))	;equal FIRST clause
     (match4 (rest p) (rest s)) )
					;new joker clause...
    ((and
      (equalp (length (first p)) 2)	; subcondition a
      (eql (first (first p)) '?) 	; subcondition b
      (let ((rest-match			; subcondition c
	       (match4 (rest p) (rest s)) ))
        (if rest-match
	    (acons (first (rest (first p)))
		   (first s)
		   rest-match) ) ) ) )
    (t nil) ) )				;extremal clause
