(in-package "USER")

(defvar *result*)
(defvar *sfeature*)

(defun recognize (lst)
    (let ((ary nil))
	(setf *sfeature* lst)
	(setf *result* nil)
	(setf ary (scan))
	(determine ary)
	(loop
	    (if (more) (return "bye"))
	    (setf *result* nil)
	    (setf ary (scan))
	    (determine ary)
	)
    )
)

(defun scan ()
    (format t "Please give me a scanned image of a character.~%")
    (read)
)

(defun determine (ary)
    (let ((feature nil))
	(setf feature
	    (append (count-peak (h-scan ary))
		    (count-peak (v-scan ary))
	    )
	)
	;(format t "feature:~S~%" feature)
	(compare feature *sfeature*)
	(if (not (null *result*))
	    (progn 
	        (format t "The scanned character may be ")
		(display *result*)
	    )
	    (format t "I cannot recognize the scanned character~%")
	)
    )
)

(defun display (lst)
    (if (null lst)
	(format t ".~%")
	(progn
	    (if (null (rest lst))
	        (format t "~S" (first lst))
		(format t "~S or " (first lst))
	    )
	    (display (rest lst))
	)
    )
)

(defun compare (lst1 lst2)
    (if (null lst2)
	nil
	(progn
	    (if (equal lst1 (rest (first lst2)))
	        (setf *result* 
		    (append *result* (list (first (first lst2))))
		)
	    )
	    (compare lst1 (rest lst2))
	)
    )
)

(defun more ()
    (format t "Do you want to test more ? (Y/N) ")
    (if (equal (read) 'n)
	t 
    )
)
