(setf flag nil)

(defun empty() (setf list nil))

(defun simply (L)
    (progn
	(sim L)
	(pop stk)
    )
)

(defun sim (L)
	(cond ( (NULL L) nil) 
	      ( (equal '+ (first L))
		  (push '+ stk)
		  (simp (rest L))
		  (if (equal (first stk) '+) 
		      (progn (pop stk)
			     (push '0 stk)
		      )
		      (progn (mk-lst)
			     (empty)
	              )
		  )
              )
	      ( (equal '* (first L))
		  (push '* stk)
		  (simm (rest L))
		  (if (equal (first stk) '*)
		      (progn (pop stk)
			     (push '0 stk)
		      )
		      (progn (mk-lst)
			     (empty)
	              )
	          )
	      )
	      ( t "Illegal Expression!" )
	)
)

(defun simp (L)
	(if (atom (first L)) 
		     (cond ( (null (first L)) nil ) 
			   ( (equal '0 (first L)) (simp (rest L)) )
			   ( t (push (first L) stk) (simp (rest L)) )
		     )
		     (progn (sim (first L))
			    (if (equal (first stk) '0) (pop stk) )
			    (simp (rest L))
	             )
	)
)

(defun simm (L)
	(if (atom (first L)) 
	             (cond ( (null (first L)) nil )
			   ( (equal '0 (first L)) (popup) )
			   ( (equal '1 (first L)) (simm (rest L)) )
			   ( t (push (first L) stk) (simm (rest L)) )
		     )
		     (progn (sim (first L))
			    (if (equal (first stk) '0)
				(popup)
			        (simm (rest L))
	                    )
	             )	
	)
)
