;   *********************** Assignment 2 **************************
;
;  This program show the respondence's psychological status. If
;  he/she corrects more than 5 of 10 stimuli then normal, otherwise
;  abnormal.
;

(IN-PACKAGE 'USER)

;   ---------------------------------------------------------------
;
;  Relational test data
;

(setf data '#(
    (light heavy bright weight sun dark)
    (sleep dream night)
    (write type pen)
    (clock time niddle noon midnight)
    (knife sharp cut sword)
    (hand grab finger claw)
    (water thirsty river ocean)
    (crow bird raven rook black)
    (photo picture camera)
    (red color warm communism apple blood)
    )
)

;   ---------------------------------------------------------------
;
; This function show 10 stimuli and examine the repondence's word
; and check the number of correction.
;

(defun word-association-test ()
   (format t "(Please type a word associated with given word)~%")
   (setf score 0) 
   (dotimes (i 10)
      (progn
         (prin1 (first (elt data i)) )
	 (prin1 ";")
	 (setf input (read) )
         (if (member input (elt data i))
	     (setf score (1+ score))
	     (weak-rela input i)
	 )
      )
   )
   (if (<= score 5) (print 'abnormal)
		    (print 'normal)
   )
)

;   ---------------------------------------------------------------
;
;  This function determine the input word is weakly related to
;  given word.
;

(defun weak-rela (input i)
    (cond
	( (= i 0) (search input ref1) )
	( (= i 1) (search input ref2) )
	( (= i 2) (search input ref3) )
	( (= i 3) (search input ref4) )
	( (= i 4) (search input ref5) )
	( (= i 5) (search input ref6) )
	( (= i 6) (search input ref7) )
	( (= i 7) (search input ref8) )
	( (= i 8) (search input ref9) )
	( (= i 9) (search input ref10) )
        (t (print "index error"))
    )
)

;   ---------------------------------------------------------------
;
;  This function search the same word in the reference data.
;  Weak relation points 0.5.
;

(defun search (input reference)
    (dotimes (j 5)
	(if (member input (elt reference j))
	    (progn
		(setf score (+ 0.5 score))
		(return)
            )
        )
    )
)
