#! /usr/local/bin/perl

#############################################################################
# hamburg.pl
# This perl program shows the order from the user input order form.
#
# @author Jungkee Kim
#

#----------------------------------------------------------------------------
# Main Function
#

&PrintHeader;
&ReadEntry &&
&PrintResult;

#----------------------------------------------------------------------------
# Subroutines
#

#----------------------
# PrintHeader
# This subroutine returns the magic line.
# Magic line informs to WWW that this is an HTML document.

sub PrintHeader {
    print "Content-type: text/html\n\n";
}

#----------------------
# ReadEntry
# Read entry from the user order form.

sub ReadEntry {
    &ReadParse;		#Read arguments passed from fill-out form
			# referred from example
    $burger1 = $in{'cheese'};
	if ($burger1 eq 'on') { $b1 = '    Cheeseburger'; }
    $burger2 = $in{'double'};
	if ($burger2 eq 'on') { $b2 = '    Doubleburger'; }
    $burger3 = $in{'chicken'};
	if ($burger3 eq 'on') { $b3 = '    Chickenburger'; }
    $burger4 = $in{'fish'};
	if ($burger4 eq 'on') { $b4 = '    Fishburger'; }
    $drink = $in{'Drink'};
    $herego = $in{'herego'};
    $name = $in{'name'};
    $phone = $in{'phone'};
    $when = $in{'when'};
    return 1;
}

#----------------------
# PrintResult
# Print the result as HTML form.

sub PrintResult {
    print "<TITLE> Burger Order </TITLE>";
    print "<H1> Burger Order </H1>";

    printf "<H3>You ordered</H3><BR>\n";
    print "$b1 $b2 $b3 $b4";
    print "$drink";
    print "$herego $name $phone $when";
    return 1;
}

#----------------------
# ReadParse
# This subroutine reads the arguments passed from the form

sub ReadParse {
    local ($i, $loc, $key, $val);

    if ($ENV{'REQUEST_METHOD'} eq "GET") {                      # Read in text
       $in = $ENV{'QUERY_STRING'};
    } elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
      for ($i = 0; $i < $ENV{'CONTENT_LENGTH'}; $i++) {
	$in .=getc;
      }
  } else 
  {  # can be used for debugging on command line
      $in = <STDIN>;
      print "$in\n";
  }

    @in = split(/&/,$in);

    foreach $i (0 .. $#in) {
      $in[$i] =~ s/\+/ /g;                          # Convert plus's to spaces
      $in[$i] =~ s/%(..)/pack("c",hex($1))/ge;
				# Convert %XX from hex numbers to alphanumeric
      $loc = index($in[$i], "=");                  # Split onto key and value.
      $key = substr($in[$i],0,$loc);
      $val = substr($in[$i],$loc+1);
      $in{$key} .= '\0' if (defined($in{$key})); # \0 is the multiple separator
      $in{$key} .= $val;
   }
   return 1;
}
