import java.lang.*;
import java.io.*;

class AuInfo {
  public static FileInputStream fp;
  public static DataInputStream dp;
  public static InputStream ip;
  public static byte buffer[] = new byte[5000];

  void FileOpen(String Afile) {
    try {
      fp = new FileInputStream(Afile);
    }
    catch(IOException e) {
      System.out.println("Error opening the file:" + Afile);
      System.exit(-1);
    }
    try {
      fp.read(buffer);
    }
    catch(IOException e) {}
    try {
      fp.close();
    }
    catch(IOException e) {}
  }

  void OpenInt() {
    ip = new ByteArrayInputStream(buffer);
    dp = new DataInputStream(ip);
  }

  int GetInt() {
    int i = 0;
    try {
      i = dp.readInt();
    }
    catch(IOException e) {}
    return i;
  }

  public static void main(String args[]) {
    byte info [] = new byte[20];
    AuInfo auinfo = new AuInfo();

    auinfo.FileOpen(args[0]);
    auinfo.OpenInt();
    int magic = auinfo.GetInt();
    int dataLocation = auinfo.GetInt();
    int dataSize = auinfo.GetInt();
    int dataFormat = auinfo.GetInt();
    int samplingRate = auinfo.GetInt();
    int channelCount = auinfo.GetInt();
    try {
      dp.read(info);
    }
    catch(IOException e) {}
    
    System.out.println("magic:" + magic);
    System.out.println("dataLocation:" + dataLocation);
    System.out.println("dataSize:" + dataSize);
    System.out.println("dataFormat:" + dataFormat);
    System.out.println("samplingRate:" + samplingRate);
    System.out.println("channelCount:" + channelCount);
    System.out.println("Info:" + info);

    for(int i = 0; i < 160; i++) {
      System.out.print(buffer[i]);
      System.out.print(' ');
      if ( (i % 16 ) == 15 ) System.out.println();
    }
  }
}
