import java.lang.*;
import java.io.*;

class ShowAuLinear {
    public static FileInputStream fp;
    public static byte buffer[] = new byte[5000];
    static int exp_lut[]= {0,132,396,924,1980,4092,8316,16764};

  public static void main(String args[]) {
    int sign, exponent, mantissa, sample, temp;

    try {
      fp = new FileInputStream(args[0]);
    }
    catch(IOException e) {
      System.out.println("Error opening a file");
      System.exit(-1);
    }
    try {
      fp.read(buffer);
    }
    catch(IOException e) {}
    int max = Integer.parseInt(args[1]);
    for(int i = 0; i < max; i++) {
      temp = buffer[i];
      temp = ~temp;
      buffer[i] = (byte)temp;
      sign = (buffer[i] & 0x80);
      exponent = (buffer[i] >> 4) & 0x07;
      mantissa = buffer[i] & 0x0F;
      sample = exp_lut[exponent] + (mantissa << (exponent+3));
      if (sign != 0) sample = -sample;
      System.out.print( sample );
      System.out.print(' ');
      if ( (i % 16 ) == 15 ) System.out.println();
    }
  }
}
