collect.h

        #ifndef __COLLECT_H
        #define __COLLECT_H

        #include <stdio.h>
        #include <stdlib.h>
        #include "node.h"

        class collection {

            node *head;
            node *tail;
            int nel;

        public:

            collection() : nel(0), head(NULL), tail(NULL) {}
            collection(const collection &src) :
                     nel(0), head(NULL), tail(NULL) {
                *this += src;
            }
            virtual ~collection(void);

            node *start(void) const {

                return !head ? NULL : head -> first(tail);}

            node *end(void) const {

                return !head ? NULL : head -> last(tail);}
            }

            int size(void) const {return nel;}
            int empty(void) const {return !nel;}
            void clear(void) {this -> collection::~collection();}

