#include <stdio.h>

typedef long fixed;

void fix_assign(fixed * this, double d) {

    *this = (long) (d * 100.0);
}

fixed fix_add(fixed *this, fixed r) {

    return (*this += r);
}

fixed fix_mult(fixed *this, fixed r) {

    return (fixed)((*this * r)/100.0);
}

double fix_double(fixed *this) {

    return ((double) *this/100.0);
}


void print_fix(fixed n) {

    printf("%d.%2d", n/100, n%100);
}

void display(char * id, fixed z) {

	printf("\nFixed value of %s is:");
	print_fixed(z);
	printf(".\n");
}

void main() {

    fixed a, b, t0, t1;
    double f;

	fix_assign(&a, 100.00);
	display("a", a);
	fix_assign(&a, 9.99);
	display("a", a);
	fix_assign(&t0, 0.00);
	display("t0", t0);
	fix_assign(&t1, 2.00);
	display("t0", t0);
	fix_add(&t0, t1);
	display("t0", t0);
	fix_mult(&t0, b);
	display("t0", t0);
	fix_add(&t0, a);
	display("t0", t0);
	f = fix_double(t0);
	printf("\nDouble value is: %f.\n", f);
}





