(defun DB-select (name &rest lst)
    (let* ((db (symbol-value name))
	   (op (first (last lst)))
	   (fields (let (r) (setf r (reverse lst)) (rest r)))
	   (result (first db))
	   order)
        (setf order (field-order (reverse fields) result))
	(DB-select-aux op order (rest db) (list result))
    )
)

(defun field-order (lists record)
    (mapcar #'(lambda (field) (position field record)) lists)
)

(defun DB-select-aux (query order data rst)
    (if data
	(progn
	    (if (apply query
		    (mapcar #'(lambda (od) (nth od (first data))) order)
	        )
	        (setf rst (append rst (list (first data))))
	    )
	    (DB-select-aux query order (rest data) rst)
	)
	rst
    )
)
