(in-package "USER")

(defvar *board*
    '#2a( (1 0 0 13 0 0 14 0 0 2)
	  (3 0 11 0 0 0 0 12 0 4)
	  (5 0 0 13 0 0 14 0 0 6)
	  (7 0 0  0 0 0 0  0 0 8)
	  (0 9 0 13 0 0 14 0 10 0)
	  (7 0 0  0 0 0  0 0 0 8)
	  (3 0 0 13 0 0 14 0 0 4)
	  (5 0 11 0 0 0 0 12 0 6)
	  (1 0 0 13 0 0 14 0 0 2)
	)
)

(defvar *red* 'r "red piece player")
(defvar *blue* 'b "blue piece player")

(defvar *r* 1 "rook")
(defvar *n* 3 "knight")
(defvar *b* 5 "bishop")
(defvar *g* 7 "guard")
(defvar *k* 9 "king")
(defvar *c* 11 "cannon")
(defvar *p* 13 "pawn")

(defvar *piece-score*
    '(0 15 15 5 5 3 3 3 3 200 200 7 7 2 2)
)

(defvar *stack* "stack for saving a piece id")

(defvar *north* 0 "north next")
(defvar *east*  1 "east next")
(defvar *west*  3 "west next")
(defvar *south* 2 "south next")

(defvar *diagonal* 4 "diagonal move")

(defvar *quit* nil "terminate condition")
(defvar *draw* 0 "draw condition")
(defvar *lose* 1 "human lose")
(defvar *win*  2 "human win")
(defvar *end*  3 "quitted")

(defvar *history* nil "history of move")

(defvar *turn* 0 "turn of play")
(defvar *level* 0 "turn of player, 0 or 1")

(defvar *look-ahead* 3 "number of plies to look ahead")
