(in-package "USER")

(defun test (L) 
    (if (or (equal (first L) 0) 
	    (equal (first (last L)) 0)
	)
	L
	"NO!"
    )
)

(defun solvable (lst1 lst2)
    (if (equal lst1 lst2)
	T
	(if (evenp (no-of-exchange lst1 lst2))
	    T
	    NIL
	)
    )
)

(defun no-of-exchange (lst1 lst2)
    (if (null lst1)
	0
	(if (eql (first lst1) (first lst2))
	    (no-of-exchange (rest lst1) (rest lst2))
	    (1+ (no-of-exchange
		    (exchange-aux (1- (location (first lst2) lst1))
				  (first lst1)
				  (rest lst1)
		    )
		    (rest lst2)
                )
	    )
	)
    )
)

(defun exchange-aux (loc ele lst)
    (if (zerop loc)
	(cons ele (rest lst))
	(cons (first lst) (exchange-aux (1- loc) ele (rest lst)))
    )
)

(defun location (num lst)
    (if (equal (first lst) num)
	0
	(1+ (location num (rest lst)))
    )
)

; 
(defun exchange (loc1 loc2 lst)
  (progn
    (if (> loc1 loc2)
	(let ((temp loc1))
	   (setf loc1 loc2)
	   (setf loc2 temp)
        )
    )
    (if (zerop loc1)
	(let (ele)
	     (setf ele (nth loc2 lst))
	     (cons ele
		   (exchange-aux (1- loc2)
				 (first lst)
				 (rest lst)
                   )
             )
        )
	(cons (first lst)
	      (exchange (1- loc1) (1- loc2) (rest lst))
	)
    )
  )
)
