(in-package "USER")

(defvar *next*
    '((0 1 3)
      (1 0 4 2)
      (2 1 5)
      (3 0 4 6)
      (4 1 3 5 7)
      (5 2 4 8)
      (6 3 7)
      (7 4 6 8)
      (8 5 7)
     )
)

(defun correspond (lst)
    (let (zloc)
	 (setf zloc (location 0 lst))
	 (correspond-zero zloc lst)
    )
)

; Zero location is 8th of the list.
; 0 -> 1 -> 2 -> 5 -> 8
;      3 -> 4 -> 5
;           6 -> 7 -> 8
(defun correspond-zero (zloc lst)
    (cond
	((eql zloc 0) (correspond-zero 1 (exchange 0 1 lst)))
	((eql zloc 1) (correspond-zero 2 (exchange 1 2 lst)))
	((eql zloc 2) (correspond-zero 5 (exchange 2 5 lst)))
	((eql zloc 3) (correspond-zero 4 (exchange 3 4 lst)))
	((eql zloc 4) (correspond-zero 5 (exchange 4 5 lst)))
	((eql zloc 5) (correspond-zero 8 (exchange 5 8 lst)))
	((eql zloc 6) (correspond-zero 7 (exchange 6 7 lst)))
	((eql zloc 7) (correspond-zero 8 (exchange 7 8 lst)))
	((eql zloc 8) lst)
    )
)
