(IN-PACKAGE 'USER)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; function PALINDROMEP
;;   that returns T if and only if LST is a palindrome, that is,
;;   if and only if LST is the same after its top-level elements
;;   have been put into reverse order.
;;
(defun palindromep (lst)
  "Returns T if and only if LST is a palindrome."
  (if (equal lst (reverse lst))
      T
      NIL
  )
)
