;   *********************** Assignment 1 **************************
;
;  This program is for a matrix multiply. It has two matrix arguments
;  and actual assignment is making 'rm' function.
;


(IN-PACKAGE 'USER)
 
;   ---------------------------------------------------------------
;
;  function mm and other functions below are made by professor Mohan.
;

(defun mm (m1 m2)
  (if (emptymatrix m1) (newemptymatrix)
      (attachrow (rm (firstrow m1) m2)
		 (mm (restofrows m1) m2)
      )
  )
)

(defun emptymatrix (m) (null m) )

(defun newemptymatrix () NIL)

(defun attachrow (r m)
       (cons r m) )

(defun firstrow (m) (first m) )

(defun restofrows (m) (rest m) )

;   ---------------------------------------------------------------
;
;  function rm is a row multiply function.
;

(defun rm (r m)
  (if (emptymatrix (first m)) (newemptymatrix)
      (append (list (madd r m) )
	      (rm r (restlist m) )
      )
  )
)


;   ---------------------------------------------------------------
;
;  function madd is a row matrix add function.
;

(defun madd (r m)
  (if (emptymatrix r) 0
    (+ (* (first r) (first (first m)) )
       (madd (rest r) (rest m))
    )
  )
)

;   ---------------------------------------------------------------
;
;  function restlist removes first elements from each row.
;

(defun restlist (m)
  (if (emptymatrix m) (newemptymatrix)
     (cons (rest (first m))
           (restlist (rest m))
     )
  )
)
