import java.applet.*;
import java.awt.*;
import java.lang.Math;
//import java.util.*;

public class SoundCurve extends Applet implements Runnable {

    Thread thread;				//Thread variable

    public void init() {			//Initialization
	thread = new Thread(this);
    }

    public void start() {

	if (thread.isAlive()) {		//Checking the life of thread
	    thread.resume();		//If other page reference,
	}				// resume the thread.

	else {				//Start thread from begining
	    thread.start();
	}
    }

    public void stop() {		//Stop thread.
	thread.suspend();
    }

    public void destroy() {		//Destroy thread.
	thread.stop();
    }

    public void run() {
	setBackground(Color.black);	//Set background as the black color
        setForeground(Color.green);
        repaint();
    }
    
    double f(double x) {
        return (Math.sin(x/10) + 2 )* size().height / 4;
    }

    public void paint(Graphics g) {
        for (int x = 0 ; x < size().width ; x++) {
            g.drawLine(x, (int)f(x), x + 1, (int)f(x + 1));
        }
    }
}
