
public class AudioCheck extends Thread
{
	AudioIOStream stream = null;
	AudioApplet owner = null;

	public AudioCheck( AudioApplet player, AudioIOStream str )
	{
		super();
		stream = str;
		owner = player;
		System.out.println( "AudioCheck: created." );
	}

	public void run()
	{
		if( ( stream == null ) || ( owner == null ) )
		{
		}
		else
		{
			while( !stream.getEOS() )
			{
				// System.out.println( "AudioCheck: checking stream status..." );
				try
				{
					sleep( 2500 );
				}
				catch( InterruptedException e )
				{
					System.err.println( "AudioCheck: InterruptedException " + e.getMessage() );
				}
			}
			owner.audioFinished();
		}
	}
}