




         ifdef __COLLECT_MAIN

         #include <string.h>
         #include "list_node.cc"

         struct ele : public list_node {

             char *key;

         public:

             ele(char *s) : key(s) {}
             ele(ele &right) : list_node(right, key(s) {}
             virtual void print(FILE *stream) {

                 list_node::print(stream);
                 printf("key=%s\n", key);
             }
             virtual node *clone(void) const {

                 return new ele(this);
             }
             virtual void clonefrom(const node *src) {

                 if (!typeof(src)) {
                     fprintf(stderr,
                             "Illegal clonefrom operation.\n");
                     exit(0);
                  }
                  key = ((ele *) src) -> key;
                  return this;
             }
             virtual int operator<(cons node &r) {
  
                 const ele *p = (const ele *)(&r);
                 return (!typeof(r) ? 0 
                         : (strcmp(key, p -> key) < 0));
             }
             virtual int operator==(const node &r) {

                 const ele *p = (const ele *)(&r);
                 return (!typeof(r) ? 0
                         : (strcmp(key, p -> key) == 0));
             }
          };

